//
//  listeD.c
//  listeD
//
//  Created by soldano on 17/09/2014.
//  Copyright (c) 2014 soldano. All rights reserved.
//



#include <stdlib.h>
#include <stdio.h>
#define Malloc(type)  (type *) malloc(sizeof(type))
#include "listesDoublementChainees.h"

/* listes doublement chainees circulaires */
/*------------------------------*/
/* definitions */
/*------------------------------*/

/* intialise et retourne une liste vide  */
listeD creerListe(){
    listeD l=NULL;
    return l;
}

/* renvoie Vrai si la liste  l est vide */
bool  	estListeVide(listeD l){
	if (l==NULL)
		return true;
	else
		return false;
}

/* renvoie la position du premier element de la liste */
/* l est non vide */
cellule* premier(listeD l){
    return l;
}

/* renvoie la position du dernier element de la liste */
/* l est non vide */
cellule* dernier(listeD l){
    return l->prec;
}

/* supprime un element  à la position p et renvoie la liste */
/* si p est Hors-Liste (NULL) ajout en queue */
listeD supprimerEnPosition(cellule * p, listeD l){
    if (p==p->suiv){ // un seul element dans liste
        free(p);
        return NULL;
    }
    if (p==l) // le premier element change
        l=l->suiv;
    // le suivant  du precedent de p devient le suivant de p
    p->prec->suiv=p->suiv;
    // le precedent du suivant de p devient le precedent de p
    p->suiv->prec= p->prec;
    free(p);
    return l;
}


/* ajoute un élément de valeur val à la position p et renvoie la liste */
/* si p est Hors-Liste (NULL) ajout en queue */
listeD 	ajouterEnPosition (element val, cellule* p,  listeD l){
    
    // pNew est l'adresse du nouvel element
    // ps est l'adresse de l'element destine a etre
    //      le sucesseur du nouvel element
    // pp est l'adresse de l'element destine a etre
    //      le predecesseur du nouvel element dans la liste circulaire
    
    cellule *pNew, *ps, *pp;
    
    pNew=Malloc(cellule);
    pNew->valeur=val;
    if (l==NULL) {// p = l =  NULL
        pNew->suiv=pNew;
        pNew->prec=pNew;
        return pNew;
    }
    if (p==l){
        l=pNew; // ajout en tete, donc la tete sera le nouvel element
    }
    if (p==HORS_LISTE){
        p= l; // ajout en queue, donc avant le premier element qui est aussi l
    }
    ps=p;
    pp=ps->prec;
    pNew->suiv=ps;
    ps->prec=pNew;
    pNew->prec=pp;
    pp->suiv=pNew;
    // ou
    // pNew->suiv=p;
    // pNew->prec=p->prec; // on a les liens vers les elements avant et apre`s dans la liste
    // pNew->prec->suiv=pNew;
    // pNew->suiv->prec=pNew; // on retablit les liens de ces elements vers pNnew
    return l;
}

/* valeur de l'element en position p dans l */
/* l n'est pas vide, p n'est pas Hors-Liste */
element valeurElement( cellule * p, listeD l){
    return p->valeur;
}
/* position du successeur de p dans l */
/* l n'est pas vide, p n'est pas Hors-Liste */
cellule * successeur(cellule * p, listeD l){
    if ( p->suiv == l){
        return NULL;
    }
    return p->suiv;
}
/* p est elle la position de fin dans l (Hors-Liste) ? */
bool fin(cellule * p, listeD l){
    return (p==NULL);
}

/* affiche les elements de la liste doublement chainee */
void 	afficherListe ( listeD l){
    cellule *pc;
    pc=l;
    printf(" liste ");
    if (pc == NULL){
        printf("vide \n");
        return ;
    }
    printf("%d ", pc->valeur);
    pc=pc->suiv;
    while(pc !=l){
        printf("%d ", pc->valeur);
        pc=pc->suiv;
    }
    printf("\n");
    return ;
}
/* affiche les elements de la liste, version avec fonctions primitives */
void 	afficherListePrim ( listeD l){
    cellule *pc;
    printf(" liste ");
    if (estListeVide(l)){
        printf("vide \n");
        return ;
    }
    pc=premier(l);
    while (!fin(pc,l)){
        printf("%d ", valeurElement(pc,l));
        pc=successeur(pc,l);
    }
    printf("\n");
    return ;
}
void viderListePrim( listeD *pl){
    /* vide la liste en libérant la me`moire. (*pl) est NULL a`la fin   */
    listeD l;
    l=(*pl);
    while (!estListeVide(l)){
        l=supprimerEnPosition(l, l); // suppression en te^te
    }
    (*pl)=l;//==NULL
    return ;
    
}
